#if defined(__cplusplus)
#define HW_EXT_API extern "C" __declspec(dllexport)
#else
#define HW_EXT_API __declspec(dllexport)
#endif

struct IHwHost
{
	// Set memory mapped address range for device.
	// This MUST be called from HW_Allocate and the return code must be checked: the emulator can refuse the address range and
	// return false, for example when the address collides with other hardware devices or with RAM.
	// If the call fails, the device can try again with a different address range.
	int (*SetAddressRange)(unsigned int base, unsigned int len);

	// Generate device interrupt
	void (*GenInterruptSync)(unsigned int level, unsigned int delay);	// delay ignored for now, level is 1-7 and should be 2
	void (*GenInterruptAsync)(unsigned int level);						// Not implemented, yet

	// Future expansion
	int (*GetInterface)(unsigned interfaceID, void **ppInterface);

	// Might be useful for debugging
	int (*SetBreakpoint)(int id, unsigned int addr);

	// Get the path for the directory containg the extension DLLs
	int (*GetExtDir)(char *szExtDirBuffer, unsigned int bufferLen);
};
